#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>



#include <ysclass.h>

#include <fssimplewindow.h>
#include "fsguiclipboard.h"

#include <ysbitmap.h>
#include <ysfontrenderer.h>
#include <ysfixedfontrenderer.h>

#include "fsgui.h"





#include <time.h>


YsColor FsGuiObject::defBgCol(0.0,0.0,1.0);
YsColor FsGuiObject::defFgCol(1.0,1.0,1.0);
YsColor FsGuiObject::defActiveBgCol(0.0,0.0,0.4);
YsColor FsGuiObject::defActiveFgCol(1.0,1.0,1.0);
YsColor FsGuiObject::defFrameCol(1.0,1.0,1.0);

YsColor FsGuiObject::defDialogBgCol(0.2,0.2,0.8);

YsColor FsGuiObject::defTabBgCol(0.1,0.1,0.9);
YsColor FsGuiObject::defTabClosedBgCol(0.0,0.0,1.0);
YsColor FsGuiObject::defTabClosedFgCol(1.0,1.0,1.0);

double FsGuiObject::defRoundRadius=0.0;

YsColor FsGuiObject::defListBgCol(0.0,0.0,0.0);
YsColor FsGuiObject::defListFgCol(1.0,1.0,1.0);
YsColor FsGuiObject::defListActiveBgCol(1.0,1.0,1.0);
YsColor FsGuiObject::defListActiveFgCol(0.0,0.0,1.0);

int FsGuiObject::defHSpaceUnit=10;
int FsGuiObject::defVSpaceUnit=16;
int FsGuiObject::defHAnnotation=12;
int FsGuiObject::defHScrollBar=12;


static YsFixedFontRenderer defaultRenderer;
class YsFontRenderer *FsGuiObject::defUnicodeRenderer=NULL;
class YsFontRenderer *FsGuiObject::defAsciiRenderer=&defaultRenderer;

////////////////////////////////////////////////////////////

YSRESULT FsGuiObject::GetUnicodeCharacterBitmapSize(int &wid,int &hei)  // Based on the size of L"X"
{
	YsBitmap bmp;
	const wchar_t xray[]={'X',0}; // Workaround to cope with 64-bit GCC bug in Mac OSX
	if(YSOK==RenderUnicodeString(bmp,xray,defFgCol,defBgCol))
	{
		wid=bmp.GetWidth();
		hei=bmp.GetHeight();
		return YSOK;
	}
	wid=0;
	hei=0;
	return YSERR;
}

YSRESULT FsGuiObject::RenderUnicodeString(YsBitmap &bmp,const char str[],const YsColor &fgCol,const YsColor &bgCol)
{
	if(NULL!=defUnicodeRenderer)
	{
		YsWString wStr;
		wStr.SetUTF8String(str);
		return defUnicodeRenderer->RenderString(bmp,wStr,fgCol,bgCol);
	}
	return YSERR;
}

YSRESULT FsGuiObject::RenderUnicodeString(YsBitmap &bmp,const wchar_t wStr[],const YsColor &fgCol,const YsColor &bgCol)
{
	if(NULL!=defUnicodeRenderer)
	{
		return defUnicodeRenderer->RenderString(bmp,wStr,fgCol,bgCol);
	}
	return YSERR;
}

YSRESULT FsGuiObject::GetTightUnicodeRenderSize(int &wid,int &hei,const wchar_t wStr[])
{
	if(NULL!=defUnicodeRenderer)
	{
		return defUnicodeRenderer->GetTightRenderSize(wid,hei,wStr);
	}
	return YSERR;
}

YSRESULT FsGuiObject::RenderAsciiString(YsBitmap &bmp,const char str[],const YsColor &fgCol,const YsColor &bgCol)
{
	if(NULL!=defAsciiRenderer)
	{
		YsWString wStr;
		wStr.SetUTF8String(str);
		return defAsciiRenderer->RenderString(bmp,wStr,fgCol,bgCol);
	}
	return YSERR;
}

YSRESULT FsGuiObject::RenderAsciiString(YsBitmap &bmp,const wchar_t str[],const YsColor &fgCol,const YsColor &bgCol)
{
	if(NULL!=defAsciiRenderer)
	{
		return defAsciiRenderer->RenderString(bmp,str,fgCol,bgCol);
	}
	return YSERR;
}

YSRESULT FsGuiObject::GetTightAsciiRenderSize(int &wid,int &hei,const char str[])
{
	if(NULL!=defAsciiRenderer)
	{
		YsWString wStr;
		wStr.SetUTF8String(str);
		return defAsciiRenderer->GetTightRenderSize(wid,hei,wStr);
	}
	return YSERR;
}

////////////////////////////////////////////////////////////

YSRESULT FsGuiObject::GetAsciiCharacterBitmapSize(int &wid,int &hei)  // Based on the size of "X"
{
	return GetAsciiStringBitmapSize(wid,hei,"X");
}

YSRESULT FsGuiObject::GetAsciiStringBitmapSize(int &wid,int &hei,const char str[])
{
	if(NULL!=defAsciiRenderer)
	{
		YsBitmap testBmp;
		YsWString wStr;
		wStr.SetUTF8String(str);
		defAsciiRenderer->RenderString(testBmp,wStr,defFgCol,defBgCol);
		wid=testBmp.GetWidth();
		hei=testBmp.GetHeight();
		return YSOK;
	}
	printf("Warning: ASCII Renderer is not set!\n");
	wid=0;
	hei=0;
	return YSERR;
}

