#include "fsguirecent.h"
#include "fsguipopupmenu.h"
#include <fssimplewindow.h>

FsGuiRecentFiles::FsGuiRecentFiles()
{
}

FsGuiRecentFiles::~FsGuiRecentFiles()
{
}

void FsGuiRecentFiles::CleanUp(void)
{
	recentFileArray.CleanUp();
}

void FsGuiRecentFiles::Save(YsTextOutputStream &outStream,YSSIZE_T nRecent) const
{
	for(auto &fn : recentFileArray)
	{
		YsString str;
		str.EncodeUTF8 <wchar_t> (fn);
		outStream.Printf("%s\n",str.Txt());

		--nRecent;
		if(0==nRecent)
		{
			break;
		}
	}
}

void FsGuiRecentFiles::Open(YsTextInputStream &inStream)
{
	CleanUp();

	YsString str;
	while(NULL!=inStream.Gets(str))
	{
		YsWString wStr;
		wStr.SetUTF8String(str);
		recentFileArray.Append(wStr);
	}
}

void FsGuiRecentFiles::AddFile(const YsWString &fn)
{
	for(YSSIZE_T idx=0; idx<recentFileArray.GetN(); ++idx)
	{
		if(0==YsWString::Strcmp(fn,recentFileArray[idx]))
		{
			while(0<idx)
			{
				YsWString tmp=(YsWString &&)recentFileArray[idx-1];
				recentFileArray[idx-1]=(YsWString &&)recentFileArray[idx];
				recentFileArray[idx]=(YsWString &&)tmp;
				--idx;
			}
			return;
		}
	}
	recentFileArray.Append(fn);
}

void FsGuiRecentFiles::PopulateMenu(class FsGuiPopUpMenu &menu,YSSIZE_T nRecent,void (*callback)(void *,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *),void *contextPtr) const
{
	int fskey=FSKEY_1;
	menu.CleanUp();
	for(auto &fn : recentFileArray)
	{
		menu.AddTextItem(0,fskey,fn,callback,contextPtr);
		if(fskey<FSKEY_9)
		{
			++fskey;
		}

		--nRecent;
		if(0>=nRecent)
		{
			break;
		}
	}
}
