#include "yssystemfontrenderer.h"
#include <yssystemfont.h>

YsSystemFontRenderer::YsSystemFontRenderer()
{
	fontCache=new YsSystemFontCache;
	Initialize();
}

YsSystemFontRenderer::~YsSystemFontRenderer()
{
	delete fontCache;
}

void YsSystemFontRenderer::Initialize(void)
{
	RequestDefaultFontWithPixelHeight(10);
}

YSRESULT YsSystemFontRenderer::RequestDefaultFontWithPixelHeight(unsigned int fontHeightInPix)
{
	return fontCache->RequestDefaultFontWithHeight(fontHeightInPix);
}

YSRESULT YsSystemFontRenderer::RenderString(YsBitmap &bmp,const wchar_t wStr[],const YsColor &fgCol,const YsColor &bgCol) const
{
	unsigned char fg[3]={(unsigned char)fgCol.Ri(),(unsigned char)fgCol.Gi(),(unsigned char)fgCol.Bi()};
	unsigned char bg[3]={(unsigned char)bgCol.Ri(),(unsigned char)bgCol.Gi(),(unsigned char)bgCol.Bi()};

	YsSystemFontTextBitmap tmpBmp;
	if(YSOK==fontCache->MakeRGBABitmap(tmpBmp,wStr,fg,bg,YSTRUE))
	{
		const unsigned int wid=tmpBmp.Width();
		const unsigned int hei=tmpBmp.Height();

		unsigned char *bmpBuf=tmpBmp.TransferBitmap();

		bmp.SetDirect(wid,hei,bmpBuf);

		return YSOK;
	}
	bmp.CleanUp();
	return YSERR;
}

YSRESULT YsSystemFontRenderer::GetTightRenderSize(int &wid,int &hei,const wchar_t wStr[]) const
{
	return fontCache->GetTightBitmapSize(wid,hei,wStr);
}

