/* ////////////////////////////////////////////////////////////

  File Name: filename.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "filename.h"
#include <ysport.h>

#include <stdio.h>



PolyCreFileName::PolyCreFileName()
{
}

PolyCreFileName::~PolyCreFileName()
{
}

/*static*/ PolyCreFileName *PolyCreFileName::Create(void)
{
	return new PolyCreFileName;
}

/*static*/ void PolyCreFileName::Delete(PolyCreFileName *ptr)
{
	delete ptr;
}

const wchar_t *PolyCreFileName::GetYsflightComDir(void) const
{
	if(0==ysflightComDir.Strlen())
	{
		YsWString appDataRoot;
		YsSpecialPath::GetUserAppDataDir(appDataRoot);
		ysflightComDir.MakeFullPathName(appDataRoot,L"YSFLIGHT.COM");
	}
	return ysflightComDir;
}

const wchar_t *PolyCreFileName::GetAppDataDir(void) const
{
	if(0==appDataDir.Strlen())
	{
		const wchar_t *ysflightComDir=GetYsflightComDir();
		appDataDir.MakeFullPathName(ysflightComDir,L"PolygonCrest");
	}
	return appDataDir;
}

const wchar_t *PolyCreFileName::GetAlternativeRootDir(void) const
{
	if(0==altRootDir.Strlen())
	{
		return NULL;
	}
	return altRootDir;
}

const wchar_t *PolyCreFileName::GetOptionDir(void) const
{
	if(0==optionDir.Strlen())
	{
		const wchar_t *rootDir=GetAlternativeRootDir();
		if(NULL==rootDir)
		{
			altRootDir=GetAppDataDir();
		}
		optionDir.MakeFullPathName(altRootDir,L"config");
	}
	return optionDir;
}

const wchar_t *PolyCreFileName::GetOptionFileName(void) const
{
	if(0==optionFile.Strlen())
	{
		optionFile.MakeFullPathName(GetOptionDir(),L"config.txt");
	}
	printf("Option File Name: %ls\n",optionFile.Txt());
	return optionFile;
}

const YsWString PolyCreFileName::GetRecentFileListFileName(void) const
{
	const wchar_t *optDir=GetOptionDir();
	YsWString wStr;
	wStr.MakeFullPathName(optDir,L"recent.txt");
	printf("Recently-Used File Names are stored in: %ls\n",wStr.Txt());
	return wStr;
}

