/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_splitop.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "ysshellextedit_splitop.h"
#include "ysshellextedit_localop.h"
#include "ysshellextedit_copyutil.h"

YSRESULT YsShellExtEdit_CutByPlane::CutByPolygon(YsShellExtEdit &shl,int np,const YsVec3 p[])
{
	if(YSOK==StartByPolygon((const YsShellExt &)shl,np,p))
	{
		YsShellExtEdit::StopIncUndo stopIncUndo(shl);

		for(YSSIZE_T spIdx=0; spIdx<edgeSplit.GetN(); ++spIdx)
		{
			edgeSplit[spIdx].createdVtHd=shl.AddVertex(edgeSplit[spIdx].pos);
			YsShellExtEdit_InsertVertexOnEdge(shl,edgeSplit[spIdx].edVtHd,edgeSplit[spIdx].createdVtHd);
		}

		if(YSOK==MakeSplitInfoAfterEdgeVertexGeneration((const YsShellExt &)shl))
		{
			for(YSSIZE_T plIdx=0; plIdx<newPlg.GetN(); ++plIdx)
			{
				for(YSSIZE_T divIdx=0; divIdx<newPlg[plIdx].plVtHdArray.GetN(); ++divIdx)
				{
					if(0==divIdx)
					{
						shl.SetPolygonVertex(newPlg[plIdx].plHd,newPlg[plIdx].plVtHdArray[divIdx]);
					}
					else
					{
						YsShellPolygonHandle newPlHd=shl.AddPolygon(newPlg[plIdx].plVtHdArray[divIdx]);
						YsShellExt_CopyPolygonAttribColorNormalFaceGroup(shl,newPlHd,newPlg[plIdx].plHd);
					}
				}
			}

			for(YSSIZE_T ceIdx=0; ceIdx<newConstEdge.GetN(); ++ceIdx)
			{
				for(YSSIZE_T divIdx=0; divIdx<newConstEdge[ceIdx].ceVtHdArray.GetN(); ++divIdx)
				{
					if(0==divIdx)
					{
						shl.ModifyConstEdge(newConstEdge[ceIdx].ceHd,newConstEdge[ceIdx].ceVtHdArray[divIdx],YSFALSE);
					}
					else
					{
						auto attrib=shl.GetConstEdgeAttrib(newConstEdge[ceIdx].ceHd);
						auto newCeHd=shl.AddConstEdge(newConstEdge[ceIdx].ceVtHdArray[divIdx],YSFALSE);
						shl.SetConstEdgeAttrib(newCeHd,attrib);
					}
				}
			}

			return YSOK;
		}
	}
	return YSERR;
}

YSRESULT YsShellExtEdit_CutByPlane::CutByPolygon(YsShellExtEdit &shl,int np,const YsShellVertexHandle p[])
{
	YsArray <YsVec3,16> vtPos(np,NULL);
	for(YSSIZE_T idx=0; idx<np; ++idx)
	{
		shl.GetVertexPosition(vtPos[idx],p[idx]);
	}
	return CutByPolygon(shl,vtPos);
}

