/* ////////////////////////////////////////////////////////////

  File Name: ysshellextplgfill.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include "ysshellextplgfill.h"
#include <ysshellext.h>


YSRESULT YsShellExtPolygonFloodFill::FloodFillSameColor(const YsShellExt &shl,YsShellPolygonHandle seedPlHd)
{
	plHdArray.CleanUp();

	YsShellPolygonStore visited((const YsShell &)shl);

	plHdArray.Append(seedPlHd);
	visited.AddPolygon(seedPlHd);

	YsColor seedCol;
	shl.GetColorOfPolygon(seedCol,seedPlHd);

	for(YSSIZE_T idx=0; idx<plHdArray.GetN(); ++idx)
	{
		const int nPlVt=shl.GetNumVertexOfPolygon(plHdArray[idx]);
		for(int neiIdx=0; neiIdx<nPlVt; ++neiIdx)
		{
			YsShellPolygonHandle neiPlHd=shl.GetNeighborPolygon(plHdArray[idx],neiIdx);
			if(NULL!=neiPlHd && YSTRUE!=visited.IsIncluded(neiPlHd))
			{
				visited.AddPolygon(neiPlHd);

				YsColor neiCol;
				shl.GetColorOfPolygon(neiCol,neiPlHd);
				if(neiCol==seedCol)
				{
					plHdArray.Append(neiPlHd);
				}
			}
		}
	}

	return YSOK;
}

YSRESULT YsShellExtPolygonFloodFill::FloodFillBoundedByConstEdge(const class YsShellExt &shl,YsShellPolygonHandle seedPlHd)
{
	plHdArray.CleanUp();

	YsShellPolygonStore visited((const YsShell &)shl);

	plHdArray.Append(seedPlHd);
	visited.AddPolygon(seedPlHd);

	for(YSSIZE_T idx=0; idx<plHdArray.GetN(); ++idx)
	{
		const int nPlVt=shl.GetNumVertexOfPolygon(plHdArray[idx]);
		for(int neiIdx=0; neiIdx<nPlVt; ++neiIdx)
		{
			YsShellVertexHandle edVtHd[2];
			shl.GetPolygonEdgeVertex(edVtHd,plHdArray[idx],neiIdx);
			if(0==shl.GetNumConstEdgeUsingEdgePiece(edVtHd))
			{
				YsShellPolygonHandle neiPlHd=shl.GetNeighborPolygon(plHdArray[idx],neiIdx);
				if(NULL!=neiPlHd && YSTRUE!=visited.IsIncluded(neiPlHd))
				{
					visited.AddPolygon(neiPlHd);
					plHdArray.Append(neiPlHd);
				}
			}
		}
	}

	return YSOK;
}

void YsShellExtPolygonFloodFill::Get(YSSIZE_T &nPl,const YsShellPolygonHandle *&plHdPtr) const
{
	nPl=plHdArray.GetN();
	plHdPtr=plHdArray;
}

