uniform "YS_GLSL_HIGHP"mat4 projection;
uniform "YS_GLSL_HIGHP"mat4 modelView;

attribute "YS_GLSL_HIGHP" vec3 vertex;
attribute "YS_GLSL_HIGHP" vec3 normal;
attribute "YS_GLSL_LOWP"vec4 colorIn;

varying "YS_GLSL_HIGHP" vec3 normalOut;
varying "YS_GLSL_HIGHP" vec3 vecToCameraOut;
varying "YS_GLSL_LOWP" vec4 color;

#include "YS_GLSL_TEXTURE_VARIABLE.glsl"
#include "YS_GLSL_ZOFFSET_VARIABLE.glsl"
#include "YS_GLSL_FOG_VARIABLES.glsl"

void main()
{
	#include "YS_GLSL_VIEW_TRANSFORM_IN_VERTEX_SHADER.glsl"
	#include "YS_GLSL_PROJECTION_TRANSFORM_IN_VERTEX_SHADER.glsl"

	"YS_GLSL_HIGHP"vec4 normal4d=vec4(normal,0);
	normalOut=normalize((modelView*normal4d).xyz);
	vecToCameraOut=-normalize(vertexInView.xyz);

	color=colorIn;

	#include "YS_GLSL_TEXTURE_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_FOG_CALCULATION_IN_VERTEXSHADER.glsl"
	#include "YS_GLSL_ZOFFSET_IN_VERTEXSHADER.glsl"

}
