/* ////////////////////////////////////////////////////////////

  File Name: ysglbuffer.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */


#include "ysglbuffer.h"

YSRESULT YsGLVertexBuffer::AddArrowHeadTriangle(const YsVec3 &p0,const YsVec3 &p1,const double arrowSize)
{
	YsVec3 edVec=p1-p0;
	const double edLen=edVec.GetLength();
	if(YsTolerance<edLen)
	{
		const double arrowLen=edLen*arrowSize;

		edVec/=edLen;
		YsVec3 uVec=YsUnitVector(edVec.GetArbitraryPerpendicularVector());
		YsVec3 vVec=edVec^uVec;

		uVec*=arrowLen*0.5;
		vVec*=arrowLen*0.5;

		const YsVec3 o=p1-edVec*arrowLen;

		AddVertex(o+uVec);
		AddVertex(o-uVec);
		AddVertex(p1);

		AddVertex(o+vVec);
		AddVertex(o-vVec);
		AddVertex(p1);

		return YSOK;
	}
	return YSERR;
}

YSRESULT YsGLVertexBuffer::AddArrowHeadTriangle(const YsVec3 p[2],const double arrowSize)
{
	return AddArrowHeadTriangle(p[0],p[1],arrowSize);
}




