#ifndef YSFILEMISC_IS_INCLUDED
#define YSFILEMISC_IS_INCLUDED
/* { */

#include <ysclass.h>
#include <stdio.h>

class YsFileIO
{
private:
	FILE *fp;
public:
	static const char *Getcwd(YsString &cwd);
	static const wchar_t *Getcwd(YsWString &cwd);

	static YSRESULT ChDir(const char dirName[]);
	static YSRESULT ChDir(const wchar_t dirName[]);

	static YSRESULT MkDir(const char dirName[]);
	static YSRESULT MkDir(const wchar_t dirName[]);

	static FILE *Fopen(const wchar_t fn[],const char mode[]);
	static FILE *Fopen(const char fn[],const char mode[]);

	static YSRESULT Remove(const wchar_t fn[]);
	static YSRESULT Remove(const char fn[]);

	YsFileIO();
	YsFileIO(const wchar_t fn[],const char mode[]);
	virtual ~YsFileIO();

	void Fclose(void);
	FILE *Fp(void) const;
};

/* } */
#endif
